//+------------------------------------------------------------------+
//|                                                    ClickMenu.mq5 |
//|                              Copyright  2016, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.00"
#property script_show_inputs
input int number_menu=1;               // ""
input int item_menu=14;                // "   "

#ifndef  _IsX64
#define HWND long
#define HMENU long
#define HBITMAP long
#define ULONG_PTR long
#else
#define HWND int
#define HMENU int
#define HBITMAP int
#define ULONG_PTR int
#endif 

#define UINT int
#define GA_ROOT            0x0002      // Retrieves the root window by walking the chain of parent windows
#define WM_COMMAND         0x0111
#define MIIM_STRING        0x00000040
#define MIIM_SUBMENU       0x00000004
#define BM_CLICK           0x000000F5

#import "user32.dll"
int  GetLastError();
//+------------------------------------------------------------------+
//| GetAncestor. Retrieves the handle to the ancestor of the         |
//| specified window.          |
//+------------------------------------------------------------------+
HWND  GetAncestor(HWND hwnd,UINT gaFlags);
HMENU GetMenu(HWND hWnd);
//int   GetMenuItemCount(HMENU hMenu);
HMENU GetSubMenu(HMENU hMenu,int   nPos);
int   GetMenuItemID(HMENU hMenu,int nPos);
bool  PostMessageW(HWND hWnd,UINT Msg,int wParam,int lParam);
HWND  GetLastActivePopup(HWND hWnd);
HWND  GetDlgItem(HWND hDlg,int nIDDlgItem);
#import
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   long  mainChartID=ChartID();                          //   
   int   hdlmainChartID=ChartWindowsHandle(mainChartID); //     
   HWND  hdlRoot=GetAncestor(hdlmainChartID,GA_ROOT);    //    
                                                         //Print("hdlRoot = ",IntegerToString(hdlRoot));

   HMENU hmenu=GetMenu(hdlRoot);                         //    
/*int count_hmenu=GetMenuItemCount(hmenu);
   Print("   ",IntegerToString(count_hmenu)," ");*/

   HMENU hsubmenu=GetSubMenu(hmenu,number_menu);         //    ("")
/*int count_hsubmenu=GetMenuItemCount(hsubmenu);
   Print("  ",IntegerToString(number_menu)," ",IntegerToString(count_hsubmenu)," ");*/
   
   int hpos=GetMenuItemID(hsubmenu,item_menu);           //   "   "
   PostMessageW(hdlRoot,WM_COMMAND,hpos,0);              //   "   "

   Sleep(2000);
   HWND hlastPopup=GetLastActivePopup(hdlRoot);          //   PopUp 
   HWND hOK=GetDlgItem(hlastPopup,0x00000001);           //    
   PostMessageW(hOK,BM_CLICK,0,0);                       //   "OK"
  }
//+------------------------------------------------------------------+
//| The function gets the handle graphics                            |
//|                                       |
//+------------------------------------------------------------------+
int ChartWindowsHandle(long chart_ID)
  {
//--- prepare the variable to get the property value
//---      
   long result=-1;
//--- reset the error value
//---   
   ResetLastError();
//--- receive the property value
//---   
   if(!ChartGetInteger(chart_ID,CHART_WINDOW_HANDLE,0,result))
     {
      //--- display the error message in Experts journal
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
